import javax.swing.*;
import java.io.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.*;

public class fftdriver extends JPanel {
	float [] realIn; 
	float [] realOut; 	
	float [] dataS;
	static AUD audio;
	PaintPanel paintPanel;	
	public fftdriver() {
		audio = new AUD();
		paintPanel = new PaintPanel();
		paintPanel.load_image("1.png");
		int width = paintPanel.getWidth();
		int height = paintPanel.getHeight();
		int size = height;
		realIn = new float[size];
		realOut = new float[size];
		for (int i = 0; i < size; i++) {
			realIn[i] = 0.0f;
			realOut[i] = 0.0f;
		}	
		dataS = new float[width*height];
		int c = 0;
		float rK = 0;
        	setBorder(BorderFactory.createEmptyBorder(20,20,20,20));
		writeOut(dataS);
		AudioThread p = new AudioThread(size,audio,paintPanel);
		p.start();
		PaintThread paint = new PaintThread(paintPanel);
		paint.start();
		PaintWidget widget = new PaintWidget(paintPanel);
		widget.addTool(new BrushDrawTool(paintPanel));
		widget.addTool(new BrushDrawTool(paintPanel,true));
		widget.addTool(new FillBoxDrawTool(paintPanel));
		widget.addTool(new FillBoxDrawTool(paintPanel,true));
		add(widget);
	}
	public void writeOut (float [] data) {
		try {
		OutputStream fileOut = new FileOutputStream(new File("out.raw"));
		DataOutputStream out = new DataOutputStream((fileOut));
		int hi = 0;
		int low = 0;
		byte hib = 0;
		byte lowb = 0;
		for (int i = 0; i < data.length; i++) {
			hi = (int)data[i];
			low = hi;
			hi <<= 16;
			hi >>= 24;
			low <<= 24;
			low >>= 24;
			lowb = (byte)low; 	
			hib = (byte)hi; 	
			out.writeByte(hib);
			out.writeByte(lowb);
			//out.writeShort(new Double(data[i]).intValue());
		}
		fileOut.close();
		} catch (Exception e) {
			System.err.println(e + "WTF");
		}
		//fileOut.close();
	}
        public static void main(String s[]) {
           JFrame frame = new JFrame("FFT Driver");
           frame.addWindowListener(new WindowAdapter() {
               public void windowClosing(WindowEvent e) {
	       	   audio.destroy();
                   System.exit(0);
               }
           });
 
           frame.setContentPane(new fftdriver());
           frame.pack();
           frame.setVisible(true);
           //frame.setSize(640,600);
        }	

}
