import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

public class PaintPanel extends ImagePanel {
	
	int needPaint = 0;
        PaintPanel (int width,int height) {
                super(width,height);
		init();
        }
        PaintPanel () {
                super();
		init();
        }
	private void init() {
	}
	void needPaint() {
		needPaint++;
	}
	boolean needsRePaint() { //listeners would be better
		if (needPaint > 0) {
			needPaint = 0;
			return true;
		}
		return false;
	} 
	void addRGB(int x, int y, int r,int g, int b) {
		if (!withinBounds(x,y)) {
			return;
		}
		int [] l = getRGBList(x,y);
		l[0] = ( l[0] + r );
		l[1] = ( l[1] + g );
		l[2] = ( l[2] + b );
		for (int i = 0; i < l.length; i++) {
			if (l[i] > 250) {
				l[i] = 250;
			} else if (l[i] < 0) {
				l[i] = 0;
			}
		}
		setRGB(x,y,l[0],l[1],l[2]);
	}
}
