public class fftreal extends fft {
	public static boolean fft ( int NumSamples, boolean InverseTransform, double [] RealIn, double [] RealOut ) {
		int NumBits;    /* Number of bits needed to store indices */
    		int i=0, j=0, k=0, n=0;
		int BlockSize=0, BlockEnd=0;
    		double angle_numerator = 2.0 * Math.PI;
		double tr, ti;     /* temp real, temp imaginary */
		if (!IsPowerOfTwo(NumSamples)) {
			return false;
		}
		if ( InverseTransform )	{
			angle_numerator = -angle_numerator;
		}
		for ( i = 0; i < NumSamples; i++) {
			RealOut[i] = 0.0;	
		}
		
		NumBits = NumberOfBitsNeeded ( NumSamples );
		for ( i = 0; i < NumSamples/ 2 ; i++) {
			//j = ReverseBits ( i, NumBits );
		        //RealOut[j] = RealIn[i];
		        //RealOut[i] = RealIn[NumSamples/2 - i - 1];
	        	//ImagOut[j] = (ImagIn == null) ? 0.0 : ImagIn[i];
	        	//RealOut[j] = (ImagIn == null) ? 0.0 : ImagIn[i];
		}

		BlockEnd = 1;
		int num2 = NumSamples / 2;
		for ( BlockSize = 2; BlockSize <= num2; BlockSize <<= 1 ) {
			double delta_angle = angle_numerator / (double)BlockSize;
			double sm2 = Math.sin ( -2 * delta_angle );
			double sm1 = Math.sin ( -delta_angle );
			double cm2 = Math.cos ( -2 * delta_angle );
			double cm1 = Math.cos ( -delta_angle );
			double w = 2 * cm1;
			double [] ar = new double[3];
			double [] ai = new double[3];
			double temp;
		        for ( i=0; i < num2; i += BlockSize ) {
			    ar[2] = cm2;
			    ar[1] = cm1;
			
			    ai[2] = sm2;
			    ai[1] = sm1;
			
			    for ( j=i, n=0; n < BlockEnd; j++, n++ )
			    {
			        ar[0] = w*ar[1] - ar[2];
			        ar[2] = ar[1];
			        ar[1] = ar[0];
			
			        ai[0] = w*ai[1] - ai[2];
			        ai[2] = ai[1];
			        ai[1] = ai[0];
				//ImagOut[k] = RealOut[NumSamples - k -1]	
			        k = j + BlockEnd;
			        tr = ar[0]*RealOut[k] - ai[0]*RealOut[NumSamples - k - 1];
			        ti = ar[0]*RealOut[NumSamples - k - 1] + ai[0]*RealOut[k];
			
			        RealOut[k] = RealOut[j] - tr;
			        RealOut[NumSamples - k - 1] = RealOut[NumSamples - j - 1] - ti;
			
			        RealOut[j] += tr;
			        RealOut[NumSamples - j - 1] += ti;
			    }
			}

		        BlockEnd = BlockSize;
    		}

		if ( InverseTransform ) {
			double denom = (double)NumSamples;

			for ( i=0; i < NumSamples; i++ )
			{
			    RealOut[i] /= denom;
			    //ImagOut[i] /= denom;
			}
    		}

		return true;

	}
	
}
